##############################################################################
# Tool Example
# テンプレートから呼び出すための関数郡を Tool と言います。
# Toolとはテンプレートに対するインターフェイスです。
# このファイルは、テンプレートlate用のクラスを宣言しています。

##############################################################################
import Globals

from Products.CMFCore import permissions
from Products.CMFCore.utils import getToolByName
from config import PROJECTNAME

# for Tool Class
from OFS.PropertyManager import PropertyManager
from Products.CMFCore.utils import UniqueObject
from OFS.SimpleItem import SimpleItem
from Products.CMFCore.ActionProviderBase import ActionProviderBase

# Permission modules
try:
    from Products.CMFCore import permissions as CMFCorePermissions
except ImportError:
    from Products.CMFCore import CMFCorePermissions
from AccessControl import ClassSecurityInfo

# Debug のためにインポートします。
from zLOG import LOG, DEBUG, INFO

# 多言語化処理のためもモジュールインストール
from zope.i18nmessageid import MessageFactory
# _ = MessageFactory('ArchExample') と等価
_ = MessageFactory(PROJECTNAME)

##############################################################################
# Tool class
##############################################################################
# Toolとして登録するクラスの実体です。
# ファイル名と同じにするのが良いです。
##############################################################################
class ExampleTool(PropertyManager, UniqueObject, SimpleItem, ActionProviderBase):
    """This is a sample article, it has an overridden view for show,
    but this is purely optional
    """

    # テンプレートから、モジュールの関数ではアクセスできないことになっています。
    # そのため security オブジェクトを利用して、各メソッドへのアクセスを許可します。
    security = ClassSecurityInfo()
    # security.setDefaultAccess('allow')  # デフォルト許可（非推奨）

    # id がテンプレートから、このオブジェクトを呼び出すための名前になります。
    plone_tool = 1
    id = 'portal_example'
    title = 'Example tool'
    # meta_typeによりToolは識別されます。UNIQUEになるように注意します。
    meta_type = 'ExampleTool'

    _properties=(
        {'id':'title', 'type': 'string', 'mode':'w'},
        )
    _actions = ()


    security.declareProtected(CMFCorePermissions.ManagePortal, 'testFunc')
    def testFunc(self):
        """Test function"""
        
        # 「zopectrl fg」や「instance fg」で起動してとき、
        # コンソールにデバッグメッセージを出力します。
        # 変数等も出力できます。
        LOG("[ArchExample]", INFO, "This message from ArchExample/ExampleTool.py")

        # メッセージです。多言語対応しています。
        msg   = _("testMsg1", default="This message from testFunc() in Product.ArchExample.ExampleTool")
        return msg

    def testFunc2(self, var1, var2):
        """Test function2"""

        # メッセージです。変数埋め込みができます。
        msg = _("testMsg2",
          default="Message embedded variable var1=${var1}, var2=${var2}",
          mapping={'var1':var1, 'var2':var2},
        )
        
        return msg

# クラスの初期化
Globals.InitializeClass(ExampleTool)
