# CMF and Archetypes import
from Products.CMFCore.utils import getToolByName
from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin

# Product Imports
from Products.ArchExample.config import PROJECTNAME, GLOBALS
from Products.ArchExample.ExampleTool import ExampleTool

from StringIO import StringIO

def install(self):
    out = StringIO()

    # 新しいコンテンツTypeをPloneに登録します。
    # config.py に設定が、__init__.py に初期化があります。
    installTypes(self, out, listTypes(PROJECTNAME), PROJECTNAME)

    # Skin directory regist
    install_subskin(self, out, GLOBALS)

    # config.py で指定した、プロダクトのコントロールパネルを登録します。
    # config.py から、コントロールパネル情報である example_configlet を
    # import して、それを登録します。
    from Products.ArchExample.config import controlpanel_configlet
    cp_tool = getToolByName(self, 'portal_controlpanel')
    try:
        cp_tool.registerConfiglet(**controlpanel_configlet)
    except:
        pass

    # Install tools
    # ExampleTool を登録します。ExampleTool.py で宣言され、
    # 親ディレクトリの __init__.py にて初期化されています。
    add_tool = self.manage_addProduct[PROJECTNAME].manage_addTool
    if not self.objectIds(spec=ExampleTool.meta_type):
        add_tool(ExampleTool.meta_type)

    out.write("Successfully installed %s." % PROJECTNAME)
    return out.getvalue()


def uninstall(self):
    out = StringIO()

    # プロダクトのコントロールパネルの登録を削除します。
    # 削除し忘れると残り続けてしまいます。
    try:
        cp_tool = getToolByName(self, 'portal_controlpanel')
        cp_tool.unregisterApplication(PROJECTNAME)
    except:
        pass

    out.write('Uninstallation completed.\n')
    return out.getvalue()
