from Products.Archetypes.public import process_types, listTypes
from Products.CMFCore import utils
from Products.CMFCore.DirectoryView import registerDirectory
from Products.CMFCore.utils import ToolInit

# config.py から設定項目にあたる値をインポートしています
from config import SKINS_DIR, GLOBALS, PROJECTNAME
from config import ADD_CONTENT_PERMISSION

# config.py の設定値と組み合わせ、テンプレートディレクトリ
#   などを登録しています。
registerDirectory(SKINS_DIR, GLOBALS)

# プロダクトで最初に呼ばれる初期化ルーチンです。
def initialize(context):
    ##Import Types here to register them
    import Article

    # Articleという新しいタイプのコンテンツを初期化しています。
    # 実体は Article.py および skins/archexample/article_view.pt です。
    # タイプの登録は Extensions/Install.py にて、
    # Plone画面上でのプロダクトインストール時に行われます。
    content_types, constructors, ftis = process_types(
        listTypes(PROJECTNAME),
        PROJECTNAME)

    utils.ContentInit(
        PROJECTNAME + ' Content',
        content_types      = content_types,
        permission         = ADD_CONTENT_PERMISSION,
        extra_constructors = constructors,
        fti                = ftis,
        ).initialize(context)

    # Toolと呼ばれる、テンプレートから直接呼び出すことのできる
    # モジュールを初期化します。
    # Toolの登録は Extensions/Install.py にて行われます。
    from ExampleTool import ExampleTool
    ToolInit(
        '%s Tool' % PROJECTNAME,
        tools=(ExampleTool,),
        product_name=PROJECTNAME,
        icon='tool.gif').initialize(context)
