##############################################################################
# このファイルはC言語で言うところのメインヘッダファイル(main.h)に相当します。
# プロダクトに関する必要な定義、および宣言はこのファイルに集中させ、
# プロダクト内の各ファイルで import して参照します。
##############################################################################
try:
    from Products.CMFCore import permissions as CMFCorePermissions
except ImportError:
    from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.permissions import AddPortalContent
from Products.Archetypes.public import DisplayList

ADD_CONTENT_PERMISSION = AddPortalContent

# プロダクトの名前を設定します。
# この名前は各ファイルから参照されます。
PROJECTNAME = "ArchExample"

# テンプレートのあるサブディレクトリ名を指定します。
# 通常変更の必要はありません。また、テンプレートディレクトリには
# さらにプロダクト名と類似のサブフォルダを作成し実際のファイルは
# その中に格納します。
SKINS_DIR = 'skins'

GLOBALS = globals()

ARTICLE_GROUPS = DisplayList((
    ('headline', 'Headline'),
    ('bulletin', 'Special Bulletin'),
    ('column', 'Weekly Column'),
    ('editorial', 'Editorial'),
    ('release', 'Press Release'),
    ))

# プロダクトインストール後、プロダクトコントロールパネルを
# 表示するための登録情報です。
controlpanel_configlet = {
    'id': 'archexample',
    'appId': PROJECTNAME,
    'name': 'Archetypes Example',
    # コントロールパネルのテンプレートを指定。
    # 例えば、plone トップページが http://***/plone/ ならば
    # http://***/plone/archexample_control_panel を登録したことになる。
    # このURLは、実際には登録したテンプレート(skins/archexample)に
    # archexample_control_panel.pt として置かれている。
    'action': 'string:$portal_url/archexample_control_panel',
    'category': 'Products',
    'permission': (CMFCorePermissions.ManagePortal,),
    # コントロールパネルのアイコンファイル。skins/archexample
    # skins/archexample/cp_tool.gif
    'imageUrl' : 'cp_tool.gif',
    }

